@ECHO OFF


REM           * * * WRAPI BUILD MODE FLAG SELECTOR * * *


REM WRAPI applications can be compiled for optimization (OPT), for
REM debugging (DBG), or for preprocessed output (PPO).  By default,
REM the mode is set to OPT to reduce the chance of shipping a product
REM with debugging information in it.


CALL APICHECK

IF (%APIDRV%)==()  APIERR DRV
IF (%APIAPP%)==()  APIERR APP
IF (%API%)==()     APIERR API

IF (%1)==(DBG)   GOTO dbg 
IF (%1)==(dbg)   GOTO dbg 
IF (%1)==(PPO)   GOTO ppo
IF (%1)==(ppo)   GOTO ppo
IF (%1)==(OPT)   GOTO opt
IF (%1)==(opt)   GOTO opt

ECHO Unknown Mode, select: DBG, PPO , or OPT.
GOTO end

:dbg

SET APIMODE=DBG
SET APIOUT=err.out
CALL API %API%
GOTO end

:ppo

SET APIMODE=PPO
SET APIOUT=%API%.out
CALL API %API%
GOTO end

:opt

SET APIMODE=OPT
SET APIOUT=err.out
CALL API %API%
GOTO end

:end
